package org.artifactory.federation;

import java.util.List;

public interface FederatedStatusService {
    /**
     * @return list of federated mirrors that have lag from activating their next event
     */
    List<MirrorLagInfo> getMirrorsLag();
    /**
     * @return status for provided repo
     */
    FederatedRepoStatusInfo getFederatedRepoStatus(String repoKey, Long currentTime);
    /**
     * @return list of federated mirrors that are not in "SYNC" status
     */
    List<UnavailableMirrorInfo> getUnavailableMirrorsByTypeAndDifferentProvidedStatus();
}
