package org.artifactory.metadata.service.interceptor;

import lombok.extern.slf4j.Slf4j;
import org.artifactory.common.MutableStatusHolder;
import org.artifactory.core.api.ph.service.PackageMetadataServiceIndexHandler;
import org.artifactory.fs.ItemInfo;
import org.artifactory.repo.interceptor.storage.StorageInterceptorAdapter;
import org.artifactory.sapi.fs.VfsItem;
import org.artifactory.sapi.interceptor.context.DeleteContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service
@Slf4j
public class MetadataIndexingInterceptorImpl extends StorageInterceptorAdapter {

    private PackageMetadataServiceIndexHandler packageMetadataServiceIndexHandler;

    @Autowired
    public void setPackageMetadataServiceIndexHandler(
            PackageMetadataServiceIndexHandler packageMetadataServiceIndexHandler) {
        this.packageMetadataServiceIndexHandler = packageMetadataServiceIndexHandler;
    }

    @Override
    public void afterDelete(VfsItem<? extends ItemInfo> fsItem, MutableStatusHolder statusHolder, DeleteContext ctx) {
        if (fsItem.isFolder()) {
            return;
        }
        packageMetadataServiceIndexHandler.deletePackageAsync(fsItem.getRepoPath());
    }
}
