package org.artifactory.ph;

import org.artifactory.descriptor.repo.RepoType;

import javax.annotation.Nonnull;

public interface PackageSpecification {

    /**
     * Indicates whether the specified path is a package in the given repository key.
     *
     * @return true if the artifact path represent a package
     */
    boolean isPackageArtifact(@Nonnull String repoKey, @Nonnull String path);

    /**
     * The method is used by Artifactory to identify whether the package type & repo type are supporting reindex
     */
    boolean hasReindex(org.artifactory.common.repo.RepoType repoType, RepoType packageType);

    /**
     * The method is used by Artifactory to identify whether the artifact is viewable from Artifactory UI
     */
    boolean isViewable(@Nonnull String repoKey, @Nonnull String path, RepoType repoPkgType);

    /**
     * Indicates whether the specified path is a package in the given repository key.
     *
     * @return true if the artifact path represent a package
     */
    boolean isPackageArtifact(@Nonnull String repoKey, @Nonnull String path, @Nonnull RepoType repoType);
}
