package org.artifactory.ph;

import org.apache.http.client.methods.CloseableHttpResponse;
import org.artifactory.addon.AddonsManager;
import org.artifactory.addon.xray.XrayAddon;
import org.artifactory.core.api.ph.service.PackageXrayService;
import org.jetbrains.annotations.Nullable;

public class PackageXrayServiceImpl implements PackageXrayService {

    private final AddonsManager addonsManager;

    public PackageXrayServiceImpl(AddonsManager addonsManager) {
        this.addonsManager = addonsManager;
    }

    @Override
    public boolean isXrayEnabled() {
        return addonsManager.addonByType(XrayAddon.class).isXrayEnabled();
    }

    @Nullable
    @Override
    public CloseableHttpResponse npmAuditReport(String strategy, String auditRequestData,
            String optionalReportToEnhance) {
        return addonsManager.addonByType(XrayAddon.class)
                .npmAuditReport(strategy, auditRequestData, optionalReportToEnhance);
    }

    @Override
    public boolean isXrayAliveByHeartbeat() {
        return addonsManager.addonByType(XrayAddon.class).isXrayAliveByHeartbeat();
    }
}
