package org.artifactory.util;

import lombok.experimental.UtilityClass;
import org.springframework.util.StopWatch;

import java.util.concurrent.Callable;

/**
 * @author Mor Merhav
 */
@UtilityClass
public class StopWatchUtil {

    public <T> T measureTime(StopWatch stopWatch, Callable<T> callable) throws Exception {
        try {
            stopWatch.start();
            T result = callable.call();
            stopWatch.stop();
            return result;
        } finally {
            if (stopWatch.isRunning()) {
                stopWatch.stop();
            }
        }
    }
}
