package org.artifactory.logging.filters;

import ch.qos.logback.core.filter.AbstractMatcherFilter;
import ch.qos.logback.core.spi.FilterReply;
import com.jfrog.sysconf.SysConfig;
import org.artifactory.api.context.ContextHelper;
import org.artifactory.common.home.ArtifactoryHome;

/**
 * @author Tomer Slutsky
 */
public class ConsoleFilter extends AbstractMatcherFilter {
    static final String ENABLE_CONSOLE_LOG_PRO_NAME = "shared.logging.enableJsonConsoleLogAppenders";
    @Override
    public FilterReply decide(Object event) {
        if (shouldPrintLog()) {
            return FilterReply.ACCEPT;
        }

        return FilterReply.DENY;
    }

    private boolean shouldPrintLog() {
        SysConfig sysConfig = ArtifactoryHome.get().getSysConfig();
        return ContextHelper.get() != null &&
                sysConfig != null && sysConfig.getBoolean(ENABLE_CONSOLE_LOG_PRO_NAME, false);
    }
}
