package org.artifactory.federated.metadata;

import java.util.Collection;
import java.util.List;

/**
 *
 * @author Alexei Vainshtein
 */
public class NegotiationException extends Exception {

    // A list of conflicts due to negotiation
    private final Collection<String> conflicts;

    public NegotiationException(String message) {
        super(message);
        conflicts = List.of();
    }

    public NegotiationException(String message, Collection<String> conflicts) {
        super(message);
        this.conflicts = conflicts;
    }

    public Collection<String> getConflicts() {
        return conflicts;
    }
}
