package org.artifactory.repo;

import com.google.common.collect.Lists;

import java.util.Arrays;
import java.util.List;

/**
 * @author Tamar Rosen
 */
public enum RepositoryConfigConverterEnum {
    ;
    private long version;
    private final RepositoriesConverter[] repositoriesConverter;

    RepositoryConfigConverterEnum(long version, RepositoriesConverter... repositoriesConverters) {
        this.version = version;
        this.repositoriesConverter = repositoriesConverters;
    }

    public static List<RepositoriesConverter> getRelevantConverters(long fromVersion) {
        List<RepositoriesConverter> converters = Lists.newArrayList();
        for (RepositoryConfigConverterEnum converterVersion : RepositoryConfigConverterEnum.values()) {
            if (converterVersion.version > fromVersion) {
                converters.addAll(Arrays.asList(converterVersion.getRepositoriesConverter()));
            }
        }
        return converters;
    }

    public RepositoriesConverter[] getRepositoriesConverter() {
        return repositoriesConverter;
    }
}
