package org.artifactory.repo.federated;

import lombok.Data;
import org.artifactory.common.config.metadata.MetadataInfo;

import java.util.Objects;

/**
 * @author Tamar Rosen
 */
@Data
public class FederatedMember {
    @MetadataInfo
    private String url;
    @MetadataInfo
    private String mode;
    @MetadataInfo(defaultValue = "true")
    private boolean enabled = true;

    public FederatedMember() {
    }

    public FederatedMember(FederatedMember federatedMember) {
        this.url = federatedMember.getUrl();
        this.mode = federatedMember.getMode();
        this.enabled = federatedMember.isEnabled();
    }

    @Override
    public int hashCode() {
        return Objects.hash(url, enabled);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        FederatedMember that = (FederatedMember) o;
        if (enabled != that.enabled) {
            return false;
        }
        return Objects.equals(url, that.url);
    }

    @Override
    public String toString() {
        return "FederatedMember{" +
                "url='" + url + '\'' +
                ", enabled=" + enabled +
                '}';
    }
}
