package org.artifactory.core.api.ph.model;

/**
 * Record class that represent a system property logic
 * @param name system property name
 * @param defaultValue default value of the property
 * @param <T> type of default value
 * see NpmSystemProperties for reference
 */
public record SystemProperty<T>(String name, T defaultValue) {
    public static <T> SystemProperty<T> of(String name, T defaultValue) {
        return new SystemProperty<>(name, defaultValue);
    }
}
