package org.artifactory.core.api.ph.service;

import org.artifactory.core.api.ph.model.sso.PackageSsoLoginModel;

import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.core.Response;
import java.util.Optional;

public interface PackageOAuthHandler {

    /**
     * Handle login from external command line tool.
     * Use basic auth to log in and return an access token.
     */
    Response handleLogin(String method, String name, String path, HttpServletRequest request,
            PackageSsoLoginModel packageSsoLoginModel);

    /**
     * Get the name of the provider specified for NPM logins (if exists)
     */
    Optional<String> getNpmLoginHandler();
}
