package org.artifactory.core.api.ph.vcs.configuration;

import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang.StringUtils;
import org.artifactory.core.api.ph.vcs.VcsUrlBuilder;

/**
 * Remote repository VcsGitConfiguration model for the PackageHandler.
 */
@Getter
@Setter
public class PhVcsGitConfiguration {

    private PhVcsGitProvider provider = PhVcsGitProvider.GITHUB;

    private String downloadUrl;

    /**
     * Constructs RepositoryDownloadUrl
     *
     * @param gitOrg  git user
     * @param gitRepo git repository
     * @param version content branch/tag
     * @param fileExt file ext
     * @return RepositoryDownloadUrl
     */
    public String buildRepositoryDownloadUrl(String gitOrg, String gitRepo, String version, String fileExt) {
        String url = StringUtils.isNotBlank(downloadUrl) ? downloadUrl : provider.getRepositoryDownloadUrl();
        return VcsUrlBuilder.repositoryDownloadUrl(url, gitOrg, gitRepo, version, fileExt);
    }
}
