package org.artifactory.core.api.ph.virtual.resolution;

public enum VirtualResolverState {
    /**
     * The first resource that is found is returned.
     * The repos order will follow priority.
     */
    returnCurrentValue,
    /**
     * Aggregates all the resources that found under the sub repositories, considering priority resolution.
     * If there was a successful response from a priority repo, the aggregation will skip the non-prioritized repos.
     */
    collectedPriority,
    /**
     * Aggregates all the resources that found under all the sub repositories (following priority repositories
     * order).
     */
    collectedAll,
}
