package org.artifactory.ui.rest.service.admin.importexport.exportdata;

import org.artifactory.api.config.ExportSettingsImpl;
import org.artifactory.sapi.common.ExportSettings;
import org.artifactory.ui.rest.model.admin.importexport.ImportExportSettings;
import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

import static org.testng.Assert.assertEquals;

/**
 * @author Alexei Vainshtein
 */
public class ExportSystemServiceTest {

    @Test(dataProvider = "actOnMissionControlProvider")
    public void testUpdateExportSettings(boolean shouldActOnMissionControl) {
        ExportSystemService exportSystemService = new ExportSystemService();
        ImportExportSettings importExportSettings = new ImportExportSettings("path");
        importExportSettings.setExcludeContent(true);
        importExportSettings.setExcludeMetadata(true);
        importExportSettings.setActOnMissionControl(shouldActOnMissionControl);
        ExportSettings exportSettings = new ExportSettingsImpl(null);
        exportSystemService.updateExportSettings(importExportSettings, exportSettings);
        assertEquals(exportSettings.shouldActOnMissionControl(), shouldActOnMissionControl);
    }

    @DataProvider
    public Object[][] actOnMissionControlProvider() {
        return new Object[][] {
                {true},
                {false}
        };
    }
}